// Wire Slave Receiver
// by Nicholas Zambetti <http://www.zambetti.com>

// Demonstrates use of the Wire library
// Receives data as an I2C/TWI slave device
// Refer to the "Wire Master Writer" example for use with this

// Created 29 March 2006

#include <Wire.h>

static unsigned char twi_state = 0;
uint8_t mbuffer[4];

// function that executes whenever data is received from master
// this function is registered as an event, see setup()
void receiveEvent(int howMany)
{
    Serial.print("Test!");
    while (Wire.available())
    {
        twi_state = Wire.receive(); // receive byte as a character
    }
//    Serial.print(twi_state, DEC);
}

// function that executes whenever data is requested by master
// this function is registered as an event, see setup()
void requestEvent()
{
    int x;
//    switch (twi_state) {
//        case 1:
            x = (int)(ToDeg(roll)*10);
            mbuffer[0] = (uint8_t)(x>>8);
            mbuffer[1] = (uint8_t)(x&0xFF);
            x = (int)(ToDeg(pitch)*10);
            mbuffer[2] = (uint8_t)(x>>8);
            mbuffer[3] = (uint8_t)(x&0xFF);
            Wire.send(mbuffer, 4);
//            Serial.print("GOT-1!");
//            break;
/*
        case 0:
        default:
            Wire.send((uint8_t)0x75);
//            Serial.print("GOT-0!");
            break;
    }
*/
}

void slave_setup()
{
    Wire.begin(0x1A); // join i2c bus with address #10
//    bitSet(TWAR, TWGCE);
    Wire.onReceive(receiveEvent); // register event
    Wire.onRequest(requestEvent); // register event
}

